<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dashboard_model extends CI_Model{
	
	function __construct(){
	
		parent::__construct();
	$this->tbl_vendor = "pos_vendor";
                $this->tbl_customers = "pos_customer";
		$this->tbl_category = "pos_category";
                $this->tbl_productgroup = "pos_productgroup";
		$this->tbl_products = "pos_products";
                $this->tbl_purchase = "pos_purchase";
                $this->tbl_sales = "pos_sales";
                $this->tbl_purchase_detail = "pos_purchase_details";
                $this->tbl_sales_detail = "pos_sales_detail";
			$this->tbl_accounts_generaljournal = "pos_accounts_generaljournal";
			$this->tbl_accounts_generaljournal_entries = "pos_accounts_generaljournal_entries";
                $this->tbl_accounts_chartofaccount = "pos_accounts_chartofaccount";
                $this->tbl_accounts_generaljournal_entries = "pos_accounts_generaljournal_entries";
	}


	public function CustomerOutstanding()
	{
                $this->db->select(''
                . 'pos_accounts_chartofaccount.ChartOfAccountId,'
                . 'pos_accounts_chartofaccount.ChartOfAccountCategoryId,'
                . 'pos_accounts_chartofaccount.ChartOfAccountControlId,'
                . 'pos_accounts_chartofaccount.ChartOfAccountCode,'
                . 'pos_accounts_chartofaccount.ChartOfAccountTitle,'
                . 'pos_accounts_generaljournal_entries.Recipient,'
                . 'pos_accounts_generaljournal.TransactionDate,'
                . 'SUM(pos_accounts_generaljournal.TotalDebit) AS TotalDebit,'
                . 'SUM(pos_accounts_generaljournal.TotalCredit) AS TotalCredit,'
                . 'SUM(pos_accounts_generaljournal_entries.Debit) AS Debit,'
                . 'SUM(pos_accounts_generaljournal_entries.Credit) AS Credit,'
                );
		$this->db->from($this->tbl_accounts_chartofaccount);
		$this->db->join($this->tbl_accounts_generaljournal_entries, $this->tbl_accounts_generaljournal_entries.'.ChartOfAccountId = '.$this->tbl_accounts_chartofaccount.'.ChartOfAccountId', 'left');
        $this->db->join($this->tbl_accounts_generaljournal, $this->tbl_accounts_generaljournal.'.GeneralJournalId = '.$this->tbl_accounts_generaljournal_entries.'.GeneralJournalId', 'left');
/*        if($AsOfDate){$this->db->where('pos_accounts_generaljournal.TransactionDate <=',$AsOfDate);}
        if($ChartOfAccountId!=0) { $this->db->where('pos_accounts_chartofaccount.ChartOfAccountId',$ChartOfAccountId); }*/
        $this->db->where('pos_accounts_chartofaccount.ChartOfAccountControlId',2);
		$this->db->group_by('pos_accounts_chartofaccount.ChartOfAccountId');
                $query = $this->db->get();
		return $query->result_array();

    }

	public function VendorOutstanding()
	{
                $this->db->select(''
                . 'pos_accounts_chartofaccount.ChartOfAccountId,'
                . 'pos_accounts_chartofaccount.ChartOfAccountCategoryId,'
                . 'pos_accounts_chartofaccount.ChartOfAccountControlId,'
                . 'pos_accounts_chartofaccount.ChartOfAccountCode,'
                . 'pos_accounts_chartofaccount.ChartOfAccountTitle,'
                . 'pos_accounts_generaljournal_entries.Recipient,'
                . 'pos_accounts_generaljournal.TransactionDate,'
//                . 'pos_accounts_generaljournal_entries.Debit,'
//                . 'pos_accounts_generaljournal_entries.Credit,'
                . 'SUM(pos_accounts_generaljournal_entries.Debit) AS Debit,'
                . 'SUM(pos_accounts_generaljournal_entries.Credit) AS Credit,'
                );
		$this->db->from($this->tbl_accounts_chartofaccount);
		$this->db->join($this->tbl_accounts_generaljournal_entries, $this->tbl_accounts_generaljournal_entries.'.ChartOfAccountId = '.$this->tbl_accounts_chartofaccount.'.ChartOfAccountId', 'left');
        $this->db->join($this->tbl_accounts_generaljournal, $this->tbl_accounts_generaljournal.'.GeneralJournalId = '.$this->tbl_accounts_generaljournal_entries.'.GeneralJournalId', 'left');
/*        if($AsOfDate){$this->db->where('pos_accounts_generaljournal.TransactionDate <=',$AsOfDate);}
        if($ChartOfAccountId!=0) { $this->db->where('pos_accounts_chartofaccount.ChartOfAccountId',$ChartOfAccountId); }*/
        $this->db->where('pos_accounts_chartofaccount.ChartOfAccountControlId',3);
		$this->db->group_by('pos_accounts_chartofaccount.ChartOfAccountId');
                $query = $this->db->get();
		return $query->result_array();

    }


	public function CurrentMonthSales()
	{
		$Date = date('Y-m');
		$CurrentDate = $Date."- 01";

            $this->db->select(''
		. 'SUM(pos_sales_detail.NetAmount) AS NetAmount');
		$this->db->from($this->tbl_sales);
		$this->db->join($this->tbl_sales_detail, $this->tbl_sales_detail.'.SaleId = '.$this->tbl_sales.'.SaleId');
		$this->db->where('pos_sales.SaleDate >=', $CurrentDate);
                $query = $this->db->get();
            if($query->num_rows() > 0) {
			return $query->result_array();
            }
	}	


	public function CurrentMonthPurchase()
	{
		$Date = date('Y-m');
		$CurrentDate = $Date.'-01';
	    $EndDate = date('Y-m-d');

                $this->db->select(''
		. 'SUM(pos_purchase_details.NetAmount) AS NetAmount');
		$this->db->from($this->tbl_purchase);
		$this->db->join($this->tbl_purchase_detail, $this->tbl_purchase_detail.'.PurchaseId = '.$this->tbl_purchase.'.PurchaseId');
		$this->db->where('pos_purchase.PurchaseDate >=', $CurrentDate);
		$this->db->where('pos_purchase.PurchaseDate <=', $EndDate);
                $query = $this->db->get();
            if($query->num_rows() > 0) {
			return $query->result_array();
            }
	}

	public function CancelledSales()
	{
        $this->db->select('*');
		$this->db->from($this->tbl_sales);
		$this->db->join($this->tbl_sales_detail, $this->tbl_sales_detail.'.SaleId = '.$this->tbl_sales.'.SaleId');
		$this->db->join($this->tbl_customers, $this->tbl_customers.'.CustomerId = '.$this->tbl_sales.'.CustomerId');
		$this->db->where('pos_sales.SaleStatus', 'Cancel');
		$this->db->group_by($this->tbl_sales.'.SaleId');
        $query = $this->db->get();
		return $query->result_array();
	}

	public function CancelledPurchases()
	{
        $this->db->select('*');
		$this->db->from($this->tbl_purchase);
		$this->db->join($this->tbl_purchase_detail, $this->tbl_purchase_detail.'.PurchaseId = '.$this->tbl_purchase.'.PurchaseId');
		$this->db->join($this->tbl_vendor, $this->tbl_vendor.'.VendorId = '.$this->tbl_purchase.'.VendorId');
		$this->db->where('pos_purchase.PurchaseStatus', 'Cancel');
		$this->db->group_by($this->tbl_purchase.'.PurchaseId');
        $query = $this->db->get();
		return $query->result_array();
	}

	function TotalSales()
	{   
	    $StartDate = '2019-05-01';
	    $EndDate = date('Y-m-d');
	    
	    $ConditionDate = "pos_sales.SaleDate BETWEEN '".$StartDate."' AND '".$EndDate."' ";
            
            $this->db->select(''
		. 'SUM(pos_sales_detail.NetAmount) AS NetAmount');
		$this->db->from($this->tbl_sales);
		$this->db->join($this->tbl_sales_detail, $this->tbl_sales_detail.'.SaleId = '.$this->tbl_sales.'.SaleId');
		$this->db->where($ConditionDate);
                $query = $this->db->get();
                
                if($query->num_rows() > 0) {
		return $query->result_array();
                }       
        }
	
	
	function TotalPurchases()
	{   
	    $StartDate = '2019-06-01';
	    $EndDate = date('Y-m-d');
	    
	    $ConditionDate = "pos_purchase.PurchaseDate BETWEEN '".$StartDate."' AND '".$EndDate."' ";

                $this->db->select(''
		. 'SUM(pos_purchase_details.NetAmount) AS NetAmount');
		$this->db->from($this->tbl_purchase);
		$this->db->join($this->tbl_purchase_detail, $this->tbl_purchase_detail.'.PurchaseId = '.$this->tbl_purchase.'.PurchaseId');
		$this->db->where($ConditionDate);
                $query = $this->db->get();
                
                if($query->num_rows() > 0) {
		return $query->result_array();
                }       
        }
	
	
	function TotalCustomers()
	{   
	    $StartDate = '2018-07-01';
	    $EndDate = date('Y-m-d');
	    

                $this->db->select(''
		. 'COUNT(pos_customer.CustomerId) AS TotalCustomers');
		$this->db->from($this->tbl_customers);
	        $query = $this->db->get();
                
                if($query->num_rows() > 0) {
		return $query->result_array();
                }       
        }
	
	
	function TotalVendors()
	{   
	    $StartDate = '2018-07-01';
	    $EndDate = date('Y-m-d');
	    
	    //$ConditionDate = "pos_salesorder.SaleOrderDate BETWEEN '".$StartDate."' AND '".$EndDate."' ";
            //$ProductArray = array();

                $this->db->select(''
		. 'COUNT(pos_vendor.VendorId) AS TotalVendors');
		$this->db->from($this->tbl_vendor);
	        $query = $this->db->get();
                if($query->num_rows() > 0) {
		return $query->result_array();
                }       
        }


	
}
?>