<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Installment_model extends CI_Model{
	
	function __construct()
	{
        parent::__construct();
	    $this->tbl_category = "pos_category";
	    $this->tbl_customer = "pos_customer";
	    $this->tbl_reference = "pos_references";
	    $this->tbl_productgroup = "pos_productgroup";
	    $this->tbl_products = "pos_products";
	    $this->tbl_sales = "pos_sales";
			$this->tbl_membership = "pos_membership";
	    $this->tbl_sales_detail = "pos_sales_detail";
	    $this->tbl_sales_cart = "pos_sales_cart";
	    $this->tbl_stocks_detail = "pos_stocks_detail";
	    $this->tbl_stock_summary = "pos_stock_summary";
	    $this->tbl_locations = "pos_locations";
	    $this->tbl_product_colours = "pos_product_colours";
		$this->tbl_banks = "pos_banks";
	    $this->tbl_bank_accounts = "pos_bank_accounts";
		$this->tbl_generaljournal = "pos_accounts_generaljournal";
		$this->tbl_generaljournal_entries = "pos_accounts_generaljournal_entries";
		$this->tbl_category = "pos_category";
		$this->tbl_installment = "pos_installment";
	}

	public function GetAllBankAccounts()
	{
	    $this->db->select('*')->from('pos_banks')->join('pos_bank_accounts', 'pos_banks.BankId = pos_bank_accounts.BankId');
	    $query = $this->db->get();
	    return $query->result_array();
	}

	public function GetLastPrice($ProductId)
	{
	    $this->db->select("NetAmount");
	    $this->db->from('pos_stocks_detail');
	    $this->db->where('ProductId', $ProductId);
//		$this->db->where('LocationId', $LocationId);
	    $this->db->order_by("ProductId", "DESC");
	    $this->db->limit('1');
	    $GetLastPrice = $this->db->get();
	    return $GetLastPrice->result_array();
	}


	public function TotalProducts($ProductId)
	{
		$this->db->select("PurchaseId,Quantity,StockType");
		$this->db->from('pos_stocks_detail');
		$this->db->where('pos_stocks_detail.ProductId', $ProductId);
//		$this->db->where('pos_stocks_detail.LocationId', $LocationId);
		$this->db->where('pos_stocks_detail.StockType', 1);
		$this->db->where('PurchaseId !=',0);
		$query = $this->db->get();
		return $query->result_array();
	}

	public function SoldProducts($ProductId)
	{
		$this->db->select('SaleId,Quantity,StockType');
		$this->db->from('pos_stocks_detail');
		$this->db->where('pos_stocks_detail.ProductId', $ProductId);
//		$this->db->where('pos_stocks_detail.LocationId', $LocationId);
		$this->db->where('pos_stocks_detail.StockType', 3);
		$this->db->where('SaleId !=',0);
		$query = $this->db->get();
		return $query->result_array();
	}
	
	function GetAllSales()
	{
	    $this->db->select('*');
	    $this->db->from($this->tbl_sales);
	    /*$this->db->join($this->tbl_product, $this->tbl_product.'.ProductId = '.$this->tbl_sales.'.ProductId');
	    $this->db->join($this->tbl_customer, $this->tbl_customer.'.StackholderId = '.$this->tbl_sales.'.StackholderId');*/
	    $query = $this->db->get();
	    return $query->result_array();	
	}

    public function Ajax_GetAllSales($requestData)
    {
       	$columns = array( 
            0 => 'InstallmentId',
            1 => 'Date',
            2 => 'Amount',
            3 => 'Remarks',
        );
		
            $sql = "SELECT pos_installment.InstallmentId, pos_installment.Date, pos_installment.Amount, pos_installment.Remarks";
            $sql.=" FROM pos_installment";

            $query= $this->db->query($sql); 
            $totalData = $query->num_rows();
            $totalFiltered = $totalData;  // when there is no search parameter then total number rows = total number filtered rows.
            $sql.=" WHERE 1=1 ";
            if( !empty($requestData['search']['value']) ) {   // if there is a search parameter, $requestData['search']['value'] contains search parameter
		    	$sql.=" AND (pos_installment.InstallmentId LIKE '".$requestData['search']['value']."%'";
				$sql.=" OR pos_installment.Date LIKE '".$requestData['search']['value']."%' ";
				$sql.=" OR pos_installment.SlipNo LIKE '".$requestData['search']['value']."%' )";
            }
		
			$query=$this->db->query( $sql) ;
			$totalFiltered = $query->num_rows(); // when there is a search parameter then we have to modify total number filtered rows as per search result. 
			$sql.=" ORDER BY ". $columns[$requestData['order'][0]['column']]."   ".$requestData['order'][0]['dir']."  LIMIT ".$requestData['start']." ,".$requestData['length']."   ";
			$query=$this->db->query($sql);  
			
			$array['record'] = $query->result_array();
			$array['recordsFiltered'] = $totalFiltered;
			$array['recordsTotal'] = $totalData;
			return $array;
        }

	function GetSales($SaleId)
	{
	    $this->db->select('*,pos_sales.AddedOn');
	    $this->db->from($this->tbl_sales);
	   	$this->db->join($this->tbl_customer, $this->tbl_customer.'.CustomerId = '.$this->tbl_sales.'.CustomerId', 'left');
	   	$this->db->join($this->tbl_category, $this->tbl_category.'.CategoryId = '.$this->tbl_sales.'.ProjectId', 'left');
	   	$this->db->join($this->tbl_products, $this->tbl_products.'.ProductId = '.$this->tbl_sales.'.PlotId', 'left');
	    $this->db->where('pos_sales.SaleId',$SaleId);
	    $query = $this->db->get();
	    return $query->row();	
	}

	function GetSalesByCustomer($CustomerId)
	{
	    $this->db->select('*,pos_sales.AddedOn');
	    $this->db->from($this->tbl_sales);
	   	$this->db->join($this->tbl_customer, $this->tbl_customer.'.CustomerId = '.$this->tbl_sales.'.CustomerId', 'left');
	   	$this->db->join($this->tbl_bank_accounts, $this->tbl_bank_accounts.'.AccountId = '.$this->tbl_sales.'.AccountId', 'left');
	   	$this->db->join($this->tbl_reference, $this->tbl_reference.'.ReferenceId = '.$this->tbl_sales.'.ReferenceId', 'left');
	    $this->db->where('pos_sales.CustomerId',$CustomerId);
	    $query = $this->db->get();
	    return $query->result_array();	
	}
	
	function GetLastSales($InvoiceNo, $CustomerId)
	{
	    $this->db->select('pos_sales.AddedOn');
	    $this->db->from($this->tbl_sales);
	    $this->db->where(['SaleId' => $InvoiceNo,'CustomerId' => $CustomerId]);
	    $query = $this->db->get();
	    $data = $query->row();	
		
		$currentDate = date('Y-m-d H:i:s');
		$checkLastSale = (array) $data;
		// check last invoice
		$this->db->select('pos_sales.AddedOn');
	    $this->db->from($this->tbl_sales);
	    $this->db->where(['CustomerId' => $CustomerId]);
		$this->db->where('AddedOn <', $checkLastSale['AddedOn']);
	    $inv = $this->db->get();
	    return $inv->row();	
	}
	
	
	function GetInstallments($SaleId)
	{
		$this->db->select('*');
		$this->db->from('pos_membership');
		$this->db->join($this->tbl_customer, $this->tbl_customer.'.CustomerId = pos_membership.MemberId');
		$this->db->where('pos_membership.MembershipId',$SaleId);
		$result = $this->db->get();
		return $result->result_array();
	}

	function GetCashDetails($SaleId)
	{
	    $this->db->select('pos_accounts_generaljournal_entries.Debit');
	    $this->db->from($this->tbl_sales);  
	    $this->db->join($this->tbl_generaljournal, $this->tbl_generaljournal.'.SaleId = '.$this->tbl_sales.'.SaleId');
		$this->db->join($this->tbl_generaljournal_entries, $this->tbl_generaljournal_entries.'.GeneralJournalId  = '.$this->tbl_generaljournal.'.GeneralJournalId');
	    $this->db->where('pos_sales.SaleId',$SaleId);
		$this->db->where('pos_accounts_generaljournal_entries.ChartOfAccountId',1);
	    $query = $this->db->get();
	    return $query->result_array();
	}
	
	
	public function SaveInstallmentDetail()
	{
		if($this->input->post('date')){ 
			$SaleDate =  date('Y-m-d', strtotime($this->input->post('date'))); 
		}else{ 
			$SaleDate = date('Y-m-d'); 
		}

		if($this->input->post('bank_account_id') != "0"){
		    $BankId = $this->input->post('bank_account_id');
		    $IdArr = explode("-", $BankId);
		    $BankId = $IdArr[0];
		    $BankChartOfAccountId = $IdArr[1];
		}
		
		$CustomerId = $this->input->post('client_id');
		$SaleId = $this->input->post('sale_id');

	    $Installment = array(
		'AccountId' => $BankId,
		'SaleId' => $this->input->post('sale_id'),
	    'date' => $SaleDate,
	    'ClientId' => $CustomerId,
		'ProjectId' => $this->input->post('project_id'),
		'ProductId' => $this->input->post('project_id'),
		'PaymentType' => $this->input->post('payment_type'),
		'SlipNo' => $this->input->post('slip_no'),
		'ChequeNo' => $this->input->post('cheque_no'),
	    'Amount' => $this->input->post('amount'),
		'NextDueDate' => date('Y-m-d', strtotime($this->input->post('discount'))),
		'Remarks' => $this->input->post('remarks'),
	    'AddedOn' => date('Y-m-d H:i:s'),
	    'AddedBy' => $this->session->userdata('EmployeeId'),
	    );

	    $this->db->insert('pos_installment', $Installment);
	    $InstallmentId = intval($this->db->insert_id());

		// insert into accounts generaljournal and its detail table
	    
	    // Gets Cash Balance chart of account from setting table
	    $CashChartOfAccountId = 1;
		$PurchaseChartOfAccountId = 2;
	 
	    $DebitAmount = $this->input->post('amount');
	    $CreditAmount = $this->input->post('amount');
		
		$VoucherType = 0;
	    $ReferenceNo = 0;
	    $DebitChartOfAccountId = 0;

		if($this->input->post('payment_type') == "1")
	    {
			$CreditChartOfAccountId = $CashChartOfAccountId;
			$VoucherType = 3;
			$ReferenceNo = $this->CRVReferenceNo();
	    }
		if($this->input->post('payment_type') == "2")
		{ 
		   $CreditChartOfAccountId = $BankChartOfAccountId;
		   $VoucherType = 2;
		   $ReferenceNo = $this->BPVReferenceNo();
        }

		// EntryType = 1 shows auto voucher created
	    $Transactions = array(
			'SaleId' => $SaleId,
			'InstallmentId' => $InstallmentId,
			'EntryType' => 1,
			'VoucherType' => $VoucherType,
			'Reference' => $ReferenceNo,
			'TransactionDate' => $SaleDate,
			'TotalDebit' => $DebitAmount,
			'TotalCredit' => $CreditAmount,
			'AddedOn' => date('Y-m-d H:i:s'),
			'AddedBy' => $this->session->userdata('EmployeeId'),
		);
		$this->db->insert('pos_accounts_generaljournal', $Transactions);
		$GeneralJournalId = intval($this->db->insert_id());


		// Following script is entering debit side entry
		$DebitTransactionDetailCash = array(
			'GeneralJournalId' => $GeneralJournalId,
			'CustomerId' => $CustomerId,
			'ChartOfAccountId' => $CreditChartOfAccountId,
			'Debit'   => $this->input->post('amount'),
			'Credit' => '0.00',
			'Detail'  => "Leasing ID : ".$SaleId. " - Installment ID ". $InstallmentId,
			);
		$this->db->insert('pos_accounts_generaljournal_entries', $DebitTransactionDetailCash);

		// create JV start
		$jv = $this->JVReferenceNo();
		$this->db->select('*');
	    $this->db->from($this->tbl_sales);
	    $this->db->where('SaleId',$SaleId);
	    $get_row = $this->db->get();
	    $get_lease = $get_row->row();
	    
	  
		$credit_amount = ($get_lease->RentPercentageAmount / $get_lease->NoOfInstallment) * ($this->input->post('amount') / $get_lease->MonthlyInstallment);
		$credit_amount = (is_nan($credit_amount)) ? 0 : round($credit_amount);
		$lease_investment = abs($this->input->post('amount') - $credit_amount);
		$Transactions = array(
			'SaleId' => $SaleId,
			'InstallmentId' => $InstallmentId,
			'EntryType' => 1,
			'VoucherType' => 5,
			'Reference' => $jv,
			'TransactionDate' => $SaleDate,
			'TotalDebit' => '0.00',
			'TotalCredit' => $credit_amount,
			'AddedOn' => date('Y-m-d H:i:s'),
			'AddedBy' => $this->session->userdata('EmployeeId'),
		);
	
		$this->db->insert('pos_accounts_generaljournal', $Transactions);
		$GeneralJournalnewId = intval($this->db->insert_id());
		
		// Following script is entering credit side entry
		$DebitTransactionDetail = array(
			'GeneralJournalId' => $GeneralJournalnewId,
			'CustomerId' => $CustomerId,
			'ChartOfAccountId' => 7,
			'Debit'   => '0.00',
			'Credit' => $credit_amount,
			'Detail'  =>  "Leasing ID : ".$SaleId. " - Installment ID ". $InstallmentId,
		);
		$this->db->insert('pos_accounts_generaljournal_entries', $DebitTransactionDetail);

		$Transactions = array(
			'SaleId' => $SaleId,
			'InstallmentId' => $InstallmentId,
			'EntryType' => 1,
			'VoucherType' => 5,
			'Reference' => $jv,
			'TransactionDate' => $SaleDate,
			'TotalDebit' => '0.00',
			'TotalCredit' => $lease_investment,
			'AddedOn' => date('Y-m-d H:i:s'),
			'AddedBy' => $this->session->userdata('EmployeeId'),
		);
	
		$this->db->insert('pos_accounts_generaljournal', $Transactions);
		$GeneralJournalnewTwoId = intval($this->db->insert_id());

		// Following script is entering credit side entry
		$CreditTransactionDetail = array(
			'GeneralJournalId' => $GeneralJournalnewTwoId,
			'CustomerId' => $CustomerId,
			'ChartOfAccountId' => 4,
			'Debit'   => '0.00',
			'Credit' => $lease_investment,
			'Detail'  => "Leasing ID : ".$SaleId. " - Installment ID ". $InstallmentId,
		);		
		$this->db->insert('pos_accounts_generaljournal_entries', $CreditTransactionDetail);
		// create JV end

		return $InstallmentId;
	}

	public function BPVReferenceNo()
	{
		$this->db->select("ReferenceNo");
		$this->db->from('pos_accounts_transaction');
		$this->db->where('TransactionType', '2');
		$this->db->order_by('AccountTransactionId', 'DESC');
		$this->db->limit('1');
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
		$row = $query->row();
		$RNo = $row->ReferenceNo;

		$iSplit = explode("BPV", $RNo);
		$data['ReferenceNo'] = $iSplit[1];

		$ReferenceNo = $data['ReferenceNo'] + 1;
		$Prefix = 'BPV';
		$NewReferenceNo = $Prefix.''.$ReferenceNo;
		return $NewReferenceNo;
		}
		else
		{ 
		$Prefix = 'BPV';
		$ReferenceNo = 1;
		$NewReferenceNo = $Prefix.''.$ReferenceNo;
		return $NewReferenceNo;
		} 
	}
	public function CPVReferenceNo()
  {
      $this->db->select("Reference");
      $this->db->from('pos_accounts_generaljournal');
      $this->db->where('VoucherType', 1);
      $this->db->order_by('GeneralJournalId', 'DESC');
      $this->db->limit('1');
      $query = $this->db->get();
      if ($query->num_rows() > 0)
      {
      $row = $query->row();
      $RNo = $row->Reference;

      $iSplit = explode("CPV", $RNo);
      $data['Reference'] = $iSplit[1];

      $ReferenceNo = $data['Reference'] + 1;
      $Prefix = 'CPV';
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      }
      else
      { 
      $Prefix = 'CPV';
      $ReferenceNo = 1;
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      } 
  }

	public function CheckStockSummary($LocationId,$ProductId,$ColourId)
	{
		$this->db->select('*')->from($this->tbl_stock_summary);
		$this->db->where('LocationId', $LocationId);
		$this->db->where('ProductId', $ProductId);
		$this->db->where('ColourId', $ColourId);
		$query = $this->db->get();
		return $query->row();
	}

	public function AddStockSummary($LocationId,$ProductId,$ColourId,$Quantity)
	{
		$StockSummary = array(
			'SummaryId' => '',
			'ProductId' => $ProductId,
			'LocationId' => $LocationId,
			'ColourId' => $ColourId,
			'Quantity' => $Quantity,
			'AddedOn' => date('Y-m-d H:i:s'),
	    	'AddedBy' => $this->session->userdata('EmployeeId'),
		);
		$this->db->insert('pos_stock_summary', $StockSummary);
		return true;
	}

	public function UpdateStockSummary($SummaryId,$LocationId,$ProductId,$ColourId,$NewQuantity)
	{
		$UpdateStockSummary = array(
			'SummaryId' => $SummaryId,
			'ProductId' => $ProductId,
			'LocationId' => $LocationId,
			'ColourId' => $ColourId,
			'Quantity' => $NewQuantity,
			'AddedOn' => date('Y-m-d H:i:s'),
	    	'AddedBy' => $this->session->userdata('EmployeeId'),
		);
		$this->db->set($UpdateStockSummary);
		$this->db->where('SummaryId',$SummaryId);
		$this->db->update('pos_stock_summary');
		return $SummaryId;
	}

	
	public function UpdateInstallmentDetail()
	{
		if($this->input->post('date')){ 
			$SaleDate =  date('Y-m-d', strtotime($this->input->post('date'))); 
		}else{ 
			$SaleDate = date('Y-m-d'); 
		}

		if($this->input->post('bank_account_id') != "0"){
		    $BankId = $this->input->post('bank_account_id');
		    $IdArr = explode("-", $BankId);
		    $BankId = $IdArr[0];
		    $BankChartOfAccountId = $IdArr[1];
		}
	
		$CustomerId = $this->input->post('client_id');
		$SaleId = $this->input->post('sale_id');

		$InstallmentId = $this->input->post('installment_id');
		$Installment = array(
			'AccountId' => $BankId,
			'SaleId' => $this->input->post('sale_id'),
			'date' => $SaleDate,
			'ClientId' => $CustomerId,
			'ProjectId' => $this->input->post('project_id'),
			'PaymentType' => $this->input->post('payment_type'),
			'SlipNo' => $this->input->post('slip_no'),
			'ChequeNo' => $this->input->post('cheque_no'),
			'Amount' => $this->input->post('amount'),
			'Discount' => $this->input->post('discount'),
			'Remarks' => $this->input->post('remarks'),
			'AddedOn' => date('Y-m-d H:i:s'),
			'AddedBy' => $this->session->userdata('EmployeeId'),
			);
	
		// Update Installment Record
	    $this->db->where('pos_installment.InstallmentId', $InstallmentId);
	    $this->db->update('pos_installment', $Installment);
	    
	    // Gets Cash Balance chart of account from setting table
	    $CashChartOfAccountId = 1;
		$PurchaseChartOfAccountId = 2;
	    
	    $DebitAmount = $this->input->post('amount');
	    $CreditAmount = $this->input->post('amount');

		$VoucherType = 0;
	    $ReferenceNo = 0;
	    $DebitChartOfAccountId = 0;

		if($this->input->post('payment_type') == "1")
	    {
			$CreditChartOfAccountId = $CashChartOfAccountId;
			$VoucherType = 3;
			$ReferenceNo = $this->CRVReferenceNo();
	    }
		if($this->input->post('payment_type') == "2")
		{ 
		   $CreditChartOfAccountId = $BankChartOfAccountId;
		   $VoucherType = 2;
		   $ReferenceNo = $this->BPVReferenceNo();
        }
	    
	    $Transactions = array(
			'TransactionDate' => $SaleDate,
			'TotalDebit' => $DebitAmount,
			'TotalCredit' => $CreditAmount,
			'Reference'   => $ReferenceNo,
			'VoucherType' => $VoucherType,
			'AddedOn' => date('Y-m-d H:i:s'),
			'AddedBy' => $this->session->userdata('EmployeeId'),
		);

		$this->db->where('pos_accounts_generaljournal.SaleId', $SaleId);
		$this->db->update('pos_accounts_generaljournal', $Transactions);
		
		
		// Gets GeneralJournal Id
		$this->db->select('GeneralJournalId');
		$this->db->from('pos_accounts_generaljournal');
		$this->db->where('pos_accounts_generaljournal.InstallmentId', $InstallmentId);
		$query = $this->db->get()->row();
		$GeneralJournalId = $query->GeneralJournalId;

		// Remove Record from pos_accounts_generaljournal_entries Before Inserting New Record
		$this->db->where('pos_accounts_generaljournal_entries.GeneralJournalId', $GeneralJournalId);
		$deleteEnteries = $this->db->delete('pos_accounts_generaljournal_entries');

		// Add Cash Reciept Voucher
		if($deleteEnteries){
			// Following script is entering debit side entry
			$DebitTransactionDetailCash = array(
				'GeneralJournalId' => $GeneralJournalId,
				'CustomerId' => $CustomerId,
				'ChartOfAccountId' => $CreditChartOfAccountId,
				'Debit'   => $this->input->post('amount'),
				'Credit' => '0.00',
				'Detail'  => "Leasing ID : ".$SaleId. " - Installment ID ". $InstallmentId,
				);
			$this->db->insert('pos_accounts_generaljournal_entries', $DebitTransactionDetailCash);

			// create JV start
			$jv = $this->JVReferenceNo();
			$this->db->select('*');
			$this->db->from($this->tbl_sales);
			$this->db->where('SaleId',$SaleId);
			$get_row = $this->db->get();
	        $get_lease = $get_row->row();
	        
			$credit_amount = ($get_lease->RentPercentageAmount / $get_lease->NoOfInstallment) * ($this->input->post('amount') / $get_lease->MonthlyInstallment);
			$credit_amount = (is_nan($credit_amount)) ? 0 : round($credit_amount);
			$lease_investment = abs($this->input->post('amount') - $credit_amount);
			$Transactions = array(
				'SaleId' => $SaleId,
				'InstallmentId' => $InstallmentId,
				'EntryType' => 1,
				'VoucherType' => 5,
				'Reference' => $jv,
				'TransactionDate' => $SaleDate,
				'TotalDebit' => '0.00',
				'TotalCredit' => $credit_amount,
				'AddedOn' => date('Y-m-d H:i:s'),
				'AddedBy' => $this->session->userdata('EmployeeId'),
			);
		
			$this->db->insert('pos_accounts_generaljournal', $Transactions);
			$GeneralJournalnewId = intval($this->db->insert_id());
			
			// Following script is entering credit side entry
			$DebitTransactionDetail = array(
				'GeneralJournalId' => $GeneralJournalnewId,
				'CustomerId' => $CustomerId,
				'ChartOfAccountId' => 7,
				'Debit'   => '0.00',
				'Credit' => $credit_amount,
				'Detail'  =>  "Leasing ID : ".$SaleId. " - Installment ID ". $InstallmentId,
			);
			$this->db->insert('pos_accounts_generaljournal_entries', $DebitTransactionDetail);

			$Transactions = array(
				'SaleId' => $SaleId,
				'InstallmentId' => $InstallmentId,
				'EntryType' => 1,
				'VoucherType' => 5,
				'Reference' => $jv,
				'TransactionDate' => $SaleDate,
				'TotalDebit' => '0.00',
				'TotalCredit' => $lease_investment,
				'AddedOn' => date('Y-m-d H:i:s'),
				'AddedBy' => $this->session->userdata('EmployeeId'),
			);
		
			$this->db->insert('pos_accounts_generaljournal', $Transactions);
			$GeneralJournalnewTwoId = intval($this->db->insert_id());

			// Following script is entering credit side entry
			$CreditTransactionDetail = array(
				'GeneralJournalId' => $GeneralJournalnewTwoId,
				'CustomerId' => $CustomerId,
				'ChartOfAccountId' => 4,
				'Debit'   => '0.00',
				'Credit' => $lease_investment,
				'Detail'  => "Leasing ID : ".$SaleId. " - Installment ID ". $InstallmentId,
			);		
			$this->db->insert('pos_accounts_generaljournal_entries', $CreditTransactionDetail);
			// create JV end
				
		}
	    return $InstallmentId;
	}


	public function BRVReferenceNo()
	{
      $this->db->select("Reference");
      $this->db->from('pos_accounts_generaljournal');
      $this->db->where('VoucherType', 4);
      $this->db->order_by('GeneralJournalId', 'DESC');
      $this->db->limit('1');
      $query = $this->db->get();
      if ($query->num_rows() > 0)
      {
      $row = $query->row();
      $RNo = $row->Reference;

      $iSplit = explode("BRV", $RNo);
      $data['Reference'] = $iSplit[1];

      $ReferenceNo = $data['Reference'] + 1;
      $Prefix = 'BRV';
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      }
      else
      { 
      $Prefix = 'BRV';
      $ReferenceNo = 1;
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      } 
     }
  


  public function CRVReferenceNo()
  {
      $this->db->select("Reference");
      $this->db->from('pos_accounts_generaljournal');
      $this->db->where('VoucherType', 3);
      $this->db->order_by('GeneralJournalId', 'DESC');
      $this->db->limit('1');
      $query = $this->db->get();
      if ($query->num_rows() > 0)
      {
      $row = $query->row();
      $RNo = $row->Reference;

      $iSplit = explode("CRV", $RNo);
      $data['Reference'] = $iSplit[1];

      $ReferenceNo = $data['Reference'] + 1;
      $Prefix = 'CRV';
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      }
      else
      { 
      $Prefix = 'CRV';
      $ReferenceNo = 1;
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      } 
  }

  public function JVReferenceNo()
  {
      $this->db->select("Reference");
      $this->db->from('pos_accounts_generaljournal');
      $this->db->where('VoucherType', 5);
      $this->db->order_by('GeneralJournalId', 'DESC');
      $this->db->limit('1');
      $query = $this->db->get();
      if ($query->num_rows() > 0)
      {
      $row = $query->row();
      $RNo = $row->Reference;

      $iSplit = explode("JV", $RNo);
      $data['Reference'] = $iSplit[1];

      $ReferenceNo = $data['Reference'] + 1;
      $Prefix = 'JV';
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      }
      else
      { 
      $Prefix = 'JV';
      $ReferenceNo = 1;
      $NewReferenceNo = $Prefix.''.$ReferenceNo;
      return $NewReferenceNo;
      } 
  }


  public function DebitRecord($CoAId)
  {
  	$this->db->select_sum('Debit')->from('pos_accounts_generaljournal_entries');
  	$this->db->where('ChartOfAccountId', $CoAId);
  	$result = $this->db->get();
  	return $result->row();
  }


    public function CreditRecord($CoAId)
    {
  	$this->db->select_sum('Credit')->from('pos_accounts_generaljournal_entries');
  	$this->db->where('ChartOfAccountId', $CoAId);
  	$result = $this->db->get();
  	return $result->row();
    }
    
    
    function AddProductInCart($ProductId)
    {
	$this->db->select('*');
	$this->db->from($this->tbl_products);
	$this->db->where('pos_products.ProductId',$ProductId);
	$query = $this->db->get();

	foreach ($query->result() as $row)
	{
	  $this->db->set('ProductId', $row->ProductId);
	  $this->db->set('ProductBarCode', $row->ProductBarCode);
	  $this->db->set('Quantity', '0');
	  $this->db->set('Rate', $row->SellPrice);
	  $this->db->set('Amount', $row->SellPrice);
	  //$this->db->set('TradePrice', $row->TradePrice);
	  $this->db->set('AddedBy', $this->session->userdata('EmployeeId'));
	  $this->db->insert('pos_sales_cart');
	}
	
	$this->db->select('*');
	$this->db->from($this->tbl_sales_cart);
	$this->db->where('pos_sales_cart.ProductId',$ProductId);
	$this->db->order_by('SaleCartId', 'DESC');
        $this->db->limit('1');
        $query = $this->db->get();
	
	if ($query->num_rows() > 0)
        {
	    $row = $query->row();
	    return $row->SaleCartId;
	}	

	//return true;
    }
    
    
    function AddBarcodeItemInCart($Barcode)
    {
	$this->db->select('*');
	$this->db->from($this->tbl_products);
	$this->db->where('pos_products.ProductBarCode',$Barcode);
	$query = $this->db->get();

	foreach ($query->result() as $row)
	{
	  $this->db->set('ProductId', $row->ProductId);
	  $this->db->set('ProductBarCode', $Barcode);
	  $this->db->set('Quantity', '0');
	  $this->db->set('Rate', $row->SellPrice);
	  $this->db->set('Amount', $row->SellPrice);
	  //$this->db->set('TradePrice', $row->TradePrice);
	  $this->db->set('AddedBy', $this->session->userdata('EmployeeId'));
	  $this->db->insert('pos_sales_cart');
	}
	return true;
    }
    
    
    function AddBarcodeItemInCart_($ProductId)
    {
	$this->db->select('*');
	$this->db->from($this->tbl_products);
	$this->db->where('pos_products.ProductBarCode',$Barcode);
	$query = $this->db->get();

	foreach ($query->result() as $row)
	{
	  $this->db->set('ProductId', $row->ProductId);
	  $this->db->set('ProductBarCode', $Barcode);
	  $this->db->set('Quantity', '1');
	  $this->db->set('Rate', $row->SellPrice);
	  $this->db->set('Amount', $row->SellPrice);
	  //$this->db->set('TradePrice', $row->TradePrice);
	  $this->db->set('AddedBy', $this->session->userdata('EmployeeId'));
	  $this->db->insert('pos_sales_cart');
	}
	return true;
    }
    
    
    function GetProductByBarcode()
    {
      $this->db->select('*');
      $this->db->from($this->tbl_sales_cart);
      $this->db->where('pos_sales_cart.AddedBy',$this->session->userdata('EmployeeId'));
      $this->db->join($this->tbl_products, $this->tbl_products.'.ProductId = '.$this->tbl_sales_cart.'.ProductId');
       $this->db->order_by("pos_sales_cart.SaleCartId", "DESC");
    //  $this->db->join($this->tbl_productgroup, $this->tbl_productgroup.'.ProductGroupId = '.$this->tbl_ims_salesorder_cart.'.ProductGroupId');
      $query = $this->db->get();
      return $query->result();
    }
    
    public function UpdateCartVal($SaleCartId,$Quantity,$Rate,$DiscountAmount)
    {
	
	$Amount = $Quantity * $Rate;
	
	$Data = array(
	'Quantity' => $Quantity,
	'Rate' => $Rate,
	'Amount' => $Amount,
	'DiscountAmount' => $DiscountAmount
	);
	
	$this->db->where('SaleCartId', $SaleCartId);
	$this->db->update('pos_sales_cart', $Data);

    }

	function DeleteSale($id)
	{
	    $this->db->where('SaleId',$id);
        $this->db->delete('pos_sales');
        return true;
	}
	function GetCustomerById($id,$columns='*')
    {   
    $finalResult = array();
        
		$this->db->select($columns);
		$this->db->from('pos_membership');
		$this->db->join('pos_customer', 'pos_customer.CustomerId = '.$this->tbl_membership.'.MemberId');
		// $this->db->join($this->tbl_membership, $this->tbl_products.'.ProductId = '.$this->tbl_sales.'.ProjectId', 'left');
		$this->db->where('pos_membership.MembershipId',$id);
		$result = $this->db->get();
		$Customers = $result->result_array();
		// echo '<pre>'; print_r($Customers); die('gh');
        $i =0;
        foreach($Customers as $customer){
			
			$installmentAmount = 0;
			$checkInstallment = $this->CheckInstallment($customer['SaleId']);
			if($checkInstallment){
				foreach($checkInstallment as $install){
				   $installmentAmount += $install['Amount'];
				}
			}
			
			$finalResult[$i]['SaleId']        	  = $customer['MembershipId'];
			$finalResult[$i]['ClientId']          = $customer['CustomerId'];
			$finalResult[$i]['ProjectId']         = $customer['ProjectId'];
            $finalResult[$i]['CustomerId']        = $customer['MemberId'];
            $finalResult[$i]['CustomerName']      = $customer['CustomerName'];
            $finalResult[$i]['CnicNo']            = $customer['Email'];
            $finalResult[$i]['ProjectName']       = $customer['CategoryName'];
            $finalResult[$i]['PlotName']       	  = $customer['ProductName'];
			$finalResult[$i]['PhoneNo']       	  = $customer['PhoneNo'];
			$finalResult[$i]['ContactName']       = $customer['ContactName'];
			$finalResult[$i]['OutstandingAmount'] = number_format($customer['GrossLeasingAmount'] - $installmentAmount, 0);
        $i++;
        }

         return $finalResult;
    }
	function CheckInstallment($SaleId)
    {
		$this->db->select('*');
		$this->db->from($this->tbl_installment);
		$this->db->where('pos_installment.SaleId',$SaleId);
		$query = $this->db->get();
		return $query->result_array();
    }
	function GetInstallmentById($InstallmentId)
    {
		$this->db->select('*');
		$this->db->from($this->tbl_installment);
		$this->db->join($this->tbl_bank_accounts, $this->tbl_bank_accounts.'.AccountId = '.$this->tbl_installment.'.AccountId', 'left');
		$this->db->join($this->tbl_banks, $this->tbl_banks.'.BankId = '.$this->tbl_bank_accounts.'.BankId', 'left');
		$this->db->where('InstallmentId',$InstallmentId);
		$result = $this->db->get();
		return $result->result_array();
		
		// $this->db->select('*');
		// $this->db->from($this->tbl_installment);
		// $this->db->where('InstallmentId',$InstallmentId);
		// $query = $this->db->get();
		// return $query->result_array();
    }

	function GetAllInstallments()
  {
		$this->db->select('InstallmentId');
		$this->db->from($this->tbl_installment);
		$result = $this->db->get();
		return $result->result_array();
  }

}
?>